***********************************************************************
* Program....: TELLME.PRG
* Author.....: Andy Kramek
* Date.......: 31 August 2002
* Notice.....: Copyright (c) 2002 Tightline Computers Ltd, All Rights Reserved
* Compiler...: Visual FoxPro 08.00.0000.1916
* Purpose....: Details of the control under the mouse pointer
***********************************************************************

LOCAL loObj, lcOHchy, lcClass, lcBClass, loParent, lcStr, lcSource, lnSave, lcParLib, lcParent
LOCAL lcCLib, lcFile, lcLoc
#DEFINE CRLF CHR(13) + CHR(10)
*** Get the object reference 
loObj    = SYS( 1270 )
IF VARTYPE( loObj ) # "O"
  RETURN
ENDIF
*** Get the associated information from the reference
lcClass  = loObj.Class
lcCLib   = loObj.ClassLibrary
*** SYS(1271) gets us the File name
lcFile   = SYS( 1271, loObj )
lcLoc = SYS(1272, loObj )
IF TYPE( "loObj.Parent" ) = "O" AND NOT ISNULL( loObj.Parent )
  loParent = loObj.Parent
  lcParent = ALLTRIM( loParent.Class ) + "::" + ALLTRIM( loParent.Name )
  lcParLib = ALLTRIM( loParent.ClassLibrary )
ELSE
  lcParent = ""
  lcParLib = ""
ENDIF
lcSource = IIF( PEMSTATUS( loObj, 'controlsource', 5 ), ALLTRIM( loObj.controlsource ), "" )
IF EMPTY( lcSource )
  lcSource = IIF( PEMSTATUS( loObj, 'recordsource', 5 ), ALLTRIM( loObj.recordsource ), "" )
ENDIF
*** Build the string
lcStr = ""
lcStr = lcStr + "Object: " + ALLTRIM( loObj.Name ) + CRLF
lcStr = lcStr + "Class: " + ALLTRIM( lcClass ) + CRLF
lcStr = lcStr + "ClassLib: " + ALLTRIM( lcCLib ) + CRLF
lcStr = lcStr + "Location: " + ALLTRIM( lcLoc ) + CRLF
lcStr = lcStr + IIF( EMPTY( lcSource ), "", "Source: " + ALLTRIM( lcSource ) + CRLF)
lcStr = lcStr + IIF( EMPTY( lcParent ), "", "Parent: " + ALLTRIM( lcParent ) + CRLF)
lcStr = lcStr + IIF( EMPTY( lcParLib ), "", "ClassLib: " + ALLTRIM( lcParLib ))
lcStr = lcStr + IIF( EMPTY( lcFile ), "", "SCX File: " + ALLTRIM( lcFile ))
*** Display it
lnSave = MESSAGEBOX( lcStr, 36, "Save Details to ClipBoard?" )
IF lnSave = 6
  _Cliptext = STRTRAN( lcStr, CRLF, "~", -1, -1, 1)
ENDIF


Searching For: '***' In File: findtext.prg
==========================================
**********************************************************************
**********************************************************************
*** Check Parameters - Search String MUST be passed
*** If no file, get one!
*** But check that the file exists (in case)
*** Get the Type of Input File (based on Extension)
*** If we have no Target file, just send output to standard text file named "FindText.Txt"
*** Get search string into local variable too
*** Create the Output file and add a header to it:
*** We have a form or class library
*** Open the file as a table
*** Get all non-deleted method code into a single string
*** Close file and restore work area
*** Just grab the entire file
*** Get data into an Array, one row per line and trim them (third param!)
*** nothing found
*** We have something to search, so go for it
*** Check each line for the search string
*** Dump it to the output file



 

**********************************************************************
* Program....: FindText
* Compiler...: Visual FoxPro 06.00.8492.00 for Windows
* Copyright..: Andy Kramek and Marcia Akins, Tightline Computers Inc, 2001
* Abstract...: Locate all Occurrences of a specified text string and dump to file
**********************************************************************
LPARAMETERS tcFindString, tcInFile, tcOutFile, tlShowLines, tlSuppressDisp
LOCAL ARRAY laLines[1]
LOCAL lcInFile, lcExt, lcOutFile, lcStr, lnSelect, lnLines, lnCnt
#DEFINE _CRLF    CHR(13)

*** Check Parameters - Search String MUST be passed
IF VARTYPE( tcFindString ) # "C" OR EMPTY( tcFindString )
    ASSERT .F. MESSAGE "Must pass a Character String to FindText()"
    RETURN .F.
ENDIF
*** If no file, get one!
IF VARTYPE( tcInFile ) # "C" OR EMPTY( tcInFile )
    lcInFile = GETFILE( 'PRG;SCX;TXT;VCX', "File", "Open", 0, "Choose File to Search" )
    IF EMPTY( lcInFile)
        ASSERT .F. MESSAGE "Must specify a file to search for FindText()"
        RETURN .F.
    ENDIF
ELSE
    lcInFile = ALLTRIM( tcInFile )
ENDIF
*** But check that the file exists (in case)
IF ! FILE( lcInFile )
    ASSERT .F. MESSAGE "Must pass an available file to search to FindText()"
    RETURN .F.
ENDIF

*** Get the Type of Input File (based on Extension)
lcExt = JUSTEXT( lcInFile )
*** If we have no Target file, just send output to standard text file named "FindText.Txt"
lcOutFile = IIF( VARTYPE( tcOutFile ) # "C" OR EMPTY( tcOutFile ),  "FindText.Txt", ALLTRIM( tcOutFile ))
*** Get search string into local variable too
lcFindStr = ALLTRIM( tcFindString )

*** Create the Output file and add a header to it:
lcStr =  "Searching For: '" + lcFindStr + "' In File: " + lcInFile
STRTOFILE( lcStr + _CRLF , lcOutFile )
STRTOFILE( REPLICATE( "=", LEN( lcStr) ) + _CRLF, lcOutFile, .T. )
STRTOFILE( _CRLF, lcOutFile, .T.)

IF INLIST( lcExt, "SCX", "VCX")
    *** We have a form or class library
    lnSelect = SELECT()
    *** Open the file as a table
    USE ( lcInfile ) IN 0 ALIAS FileToSch
    *** Get all non-deleted method code into a single string
    SELECT FileToSch
    lcStr = ""
    SCAN FOR ! DELETED()
        lcStr = lcStr + ALLTRIM( METHODS )
    ENDSCAN
    *** Close file and restore work area
    USE IN FileToSch
    SELECT (lnSelect)
ELSE
    *** Just grab the entire file 
    lcStr = FILETOSTR( lcInFile )
ENDIF

*** Get data into an Array, one row per line and trim them (third param!)
lnLines = 0
lnLines = ALINES( laLines, lcStr, .T.)
IF lnLines < 1
    *** nothing found
    RETURN .F.
ENDIF
*** We have something to search, so go for it
FOR lnCnt = 1 TO lnLines
    *** Check each line for the search string
    IF lcFindStr $ laLines[lnCnt]
        *** Dump it to the output file
        IF tlShowLines
          STRTOFILE( "Line " + TRANSFORM(lnCnt) + ";  " + laLines[lnCnt] + _CRLF, lcOutFile, .T.)
        ELSE
          STRTOFILE( laLines[lnCnt] + _CRLF, lcOutFile, .T.)
        ENDIF
    ENDIF
NEXT

IF ! tlSuppressDisp
  MODI FILE (lcOutFile) NOWAIT
ENDIF


********************************************************************
*** Name.....: GETFOXDBC.PRG
*** Author...: Andy Kramek
*** Date.....: 1/1/2005
*** Notice...: Copyright (c) 2005 Tightline Computers, Inc
*** Compiler.: Visual FoxPro 08.00.0000.3117 for Windows 
*** Function.: Get a listing of all tables in a DBC and write the fields out to a text file
********************************************************************
LPARAMETERS tcDBC, tlNoStru
LOCAL lcTable, lnCnt, lcOutFile, lcStr, lnFields
CLOSE ALL
*** Define some constants here
#DEFINE CRLF  CHR(13) + CHR(10) 
#DEFINE _LINE CRLF + REPLICATE( "=", 60 ) + CRLF
SET ASSERTS ON

*** Create the Output File
lcOutFile = ALLTRIM( tcDBC ) + ".txt"
lcStr = "Table Definitions for " + UPPER(ALLTRIM( tcDBC )) + " database" + _LINE + CRLF
STRTOFILE( lcStr, lcOutFile )

*** Get the tables
lcDbc = FORCEEXT( tcDBC, 'dbc' )
SELECT objectname AS table_name ;
  FROM (lcDBC) ;
WHERE objecttype = 'Table' INTO CURSOR curTables

USE IN (tcDBC)
SELECT curTables
GO TOP
SCAN
  *** Get the table name and open it
  lcTable = ALLTRIM( table_name )
  lcStr = CRLF + PROPER( lcTable ) + CRLF + CRLF
  STRTOFILE( lcStr, lcOutFile, 1 )
  USE (lcTable) IN 0
  SELECT (lcTable) 

  *** Get the field Data
  lnFields = AFIELDS( laFields )
  lcStr = ''
  FOR lnCnt = 1 TO lnFields
    *** Field Definition
    lcStr = lcStr + LOWER( laFields[lnCnt,1] ) 
    IF NOT tlNoStru
      lcStr = lcStr + "   " + laFields[lnCnt,2] + " (" ;
      + PADL( laFields[lnCnt,3], 3 ) ;
      + IIF( EMPTY( laFields[lnCnt,4] ), '', ',' + ALLTRIM( STR( laFields[lnCnt,4] ))) + ' )'
    ENDIF
    lcStr = lcStr + CRLF
  NEXT
  
  *** Write out field list 
  STRTOFILE( lcStr, lcOutFile, 1 )

  *** Process the list
  USE IN (lcTable)
  SELECT curTables
ENDSCAN